/*
 * code-name 'KOTETU'
 *
 * admin_config.c :
 *
 *      by k-chinen@is.aist-nara.ac.jp, 1999
 *
 * $Id$
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif


#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>

#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif

#ifdef HAVE_STROPTS_H
#include <stropts.h>
#endif
#ifdef HAVE_POLL_H
#include <poll.h>
#include <sys/poll.h>
#endif
#ifdef HAVE_SELECT_H
#include <sys/select.h>
#endif

#ifdef __STDC__
#include <stdarg.h>
#else
#include <varargs.h>
#endif


#include <strings.h>
#include <limits.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <time.h>
#include <sys/wait.h>
#include <sys/resource.h>
#include <signal.h>
#include <fcntl.h>
#include <sys/file.h>
#include <sys/ioctl.h>
#include <errno.h>


#include "wcol.h"
#include "socket.h"
#include "sim_stat.h"
#include "http.h"
#include "misc.h"
#include "sess.h"



/*
 * externals
 */

/* automatic */
char    config_filename[L_URL];
int     trace_flag;
int     prefetch_flag;
int     monitor_flag;
int     service_portno;
int     require_n_handler;
int     require_chunk_size;
int     require_total_memory_size;
int     require_num_large_block;
int     require_size_large_block;
int     require_size_block;
int     require_minimum_size_line;
int     require_sess_length;
int num_prefetch_referedpages;
int num_prefetch_includedobjs;

char *localdomain_padding;
char *report_hook_hostname;


#if 0
/* static */
static pid_t    wcol_pid;
static char     *progname;
#endif


int
show_cont_proxy_configfile_fd(char *fname, int ofd)
{
    int chk;


    /***
     *** Initialize
     ***/

    trace_flag = 1;

    SetGlobalDefaults();
#if 0
    if(getenv(DEFAULT_CONFIG_ENVNAME)!=NULL) {
        strcpy(config_file, getenv(DEFAULT_CONFIG_ENVNAME));
    }
    ReadConfigFile(config_file);
    ReadCommandlineOptions(argc, argv);

    /*
     *
     */
    FixGlobals();
    if(trace_flag) {
        ShowGlobals(stdout);
    }
#endif

    chk = ReadConfigFile(fname);
    if(chk) {
        fdprintf(ofd, "not found such configuration file\n");
    }

    ShowGlobals_fd(ofd);

    return 0;
}
