#include <stdio.h>

/* used for index */
static int prime_box[] = {23,19,13,31,11,67,7,71,5,3,29};
static int prime_box2[] = {7,191,17,13,27,127,83,241,59,281,293,19,};
static int prime_box3[] = {229,113,251,181,257,149,137,293,223,263,211,};
static int prime_box4[] = {22,113,251,181,7,149,137,5,223,263,211,};

/*
int    radix_h1 = 27;
int    radix_h2 = 23;
int    radix_h3 = 17;
int    radix_h4 = 499;
*/
int    radix_h1 = 57;
int    radix_h2 = 23;
int    radix_h3 = 27;
int    radix_h4 = 499;


int
first_hash(unsigned char *b)
{
    int l;
    register int sum, c;
    register unsigned char *p, *r, *s;

    sum = 0;

    c = 1;
    p = b;
    while(*p) {
        sum += *p - ' ' + c;
        if(*p>='0' && *p<='9') {
            sum += prime_box2[*p - '0'];
        }
		else {
			sum += prime_box3[(c+*p)%10];
		}
        p++;
        c++;
    }

    if(sum<0)
        sum = -sum;

    return sum % radix_h1;
}

int
second_hash(unsigned char *b)
{
    register int sum;
    register unsigned char *p;
    register int c;

    sum = 0;
    c = 1;

    p = b;
    while(*p) {
        if(*p>='0' && *p<='9') {
        	sum += prime_box3[*p - '0'] - c;
		}
		else {
			sum += prime_box4[*p%10] + c;
		}
        c++;
        p++;
    }

    if(sum<0)
        sum = -sum;

    return sum % radix_h2;
}

int
third_hash(unsigned char *b)
{
    register int sum;
    register unsigned char *p;
    register int c;

    sum = 0;
    c = 1;

    p = b;
    while(*p) {
        sum += prime_box3[(c+*p)%10];
        c++;
        p++;
    }

    if(sum<0)
        sum = -sum;

    return sum % radix_h3;
}


int
fourth_hash(unsigned char *b)
{
    register int sum;
    register unsigned char *p;
    register unsigned char q;
    register int c;

    sum = 0;
    c = 1;

    p = b;
    q = 127;
    while(*p) {
        sum += q + *p + prime_box4[*p%10] - prime_box3[c%10];
        q = *p;
        c++;
        p++;
    }

/*
printf("sum %d\n", sum);
*/
    if(sum<0)
        sum = -sum;

    return sum % radix_h4;
}





solve_hash(char *x)
{
	int h1, h2, h3, h4;

	h1 = first_hash(x);
	h2 = second_hash(x);
	h3 = third_hash(x);
	h4 = fourth_hash(x);
	
	printf("%3d %3d %3d %3d %s\n", h1, h2, h3, h4, x);
}

char *a="http://10.17.130.175:8080/w0357aec0.786d81fa:0000016e/t04/_00000001";
char *b="http://10.17.130.126:8080/w0357aeb6.3aa298e9:0000026e/t04/_00000001";
char *c="http://10.17.130.126:8080/w0357aeb6.3aa298e9:0000036e/t04/_00000001";

char *u="http://10.17.131.23:8080/w0357be08.17a29930:7ffffcef/t01/_00000205.jpeg";
char *v="http://10.17.129.45:8080/w0357be08.17a29930:0000005c/t02/_00000016.htm";


#if 0
char *x="http://10.17.131.153:8080/w0357be08.17a29930:7ffffbeb/t01/_0000040b.png";
char *y="http://10.17.129.20:8080/w0357be08.17a29930:7fffffd5/t01/_00000606.jpeg";
#endif
char *x="http://10.17.129.4:8080/w03586048.6dd20257:7fffff4d/t01/_00000105.png";
char *y="http://10.17.129.4:8080/w03586048.6dd20257:7fffff5d/t01/_00000104.png";

x_main()
{
	solve_hash(a);
	solve_hash(b);
	solve_hash(c);

	solve_hash(u);
	solve_hash(v);

	solve_hash(x);
	solve_hash(y);
}


main()
{
	char line[BUFSIZ];
	int h1, h2, h3, h4;

	while(fgets(line, BUFSIZ, stdin)!=NULL) {
		if(strncmp(line, "http://",7)==0) {

			h1 = first_hash(line);
			h2 = second_hash(line);
			h3 = third_hash(line);
			h4 = fourth_hash(line);
		
			printf("%03d-%03d-%03d-%03d %s", h1, h2, h3, h4, line);
		}
	}


}



