/*
 * skcache.h - object cache procedures for KOTETU
 *      by k-chinen@is.aist-nara.ac.jp, 2000
 *
 *
 */

typedef struct _obj_frag {
    int size;
    int len;
    char *ent;
    struct _obj_frag *next;
} skcache_frag_t;

typedef struct _skcache_entry_t {
    int h1, h2, h3;         /* tripple hash */
    int oid;
    unsigned char name[L_URL];

    int count;
    int ref;
    int owner;
    int cracked;

    time_t issue_time;
    time_t hot;
    time_t lmd;                     /* last modified */
    time_t expire;                  /* expire */

    int totallength;
    skcache_frag_t *m_recorded;
    int d_recorded;

    struct _skcache_entry_t *next;

} skcache_entry_t;



extern skcache_entry_t *NIL;
extern int skcache_bucket_num;
extern bucket_t *skcache_bucket_base;
extern skcache_entry_t **skcache_entry_freelist_base;
extern skcache_frag_t   **skcache_frag_freelist_base;

int skcache_entry_cmp(void *px, void *py);
char* skcache_label_hash(void *pp);
char* skcache_label_ref(void *pp);
char* skcache_label_short(void *pp);

int skcache_have(int , int , int , char *, int , time_t );

long long skcache_init(int xbucket_num, int xsk_level, int xsk_num,
        int xfl_num, int xfl_size
);



